#include <bits/stdc++.h>
using namespace std;
int main()
{
	ifstream fi("rn.inp");
	ofstream fo("rn.out");
	int n;
    fi>>n;
    int a[n];
    int k=1;
    for(int i=0;i<n;i++)
    {
        fi>>a[i];
    }
    for(int i=1;i<n;i++)
    {
        if(a[i]>a[i-1])
        {
            k++;
        }
        else
        {
            break;
        }
    }
    fi.close();
    for(int i=0;i<k;i++)
    {
        a[n]=a[i];
        n++;
    }
    int maxd=0;
    int d=0,c=0;int r;
    int tg=0;
    for(int i=0;i<n;i++)
    {
        int dem=0;
        int t=0;
        for(int j=i;j<n;j++)
        {
            if(a[j]<a[j+1])
            {
                dem++;
                t=a[j]+t;
                r=j;
        	
            if(dem>maxd)
            {
                maxd=dem;
                d=i;
                c=r+1;
                tg=t;
            }
            else
				{
					if (dem==maxd)
					{
						if(t<tg)
						{
							maxd=dem;
                    		d=i;
                    		c=r+1;
                    		tg=t;
						}
					}
        		}	
        	}
            else
            {
                    break;
            }
        }
    }
    for(int i=d;i<=c;i++)
    {
        fo<<a[i]<<' ';
    }
    fo.close();
}
